// SPDX-License-Identifier: Apache-2.0
import { createMock } from "@golevelup/ts-jest";
import { ErrorMsgFixture, EvmAddressPropsFixture, HederaIdPropsFixture, TransactionIdFixture, } from "../../../../../../../__tests__/fixtures/shared/DataFixture";
import EvmAddress from "../../../../../../domain/context/contract/EvmAddress";
import Account from "../../../../../../domain/context/account/Account";
import { SecurityRole } from "../../../../../../domain/context/security/SecurityRole";
import { ActivateInternalKycCommandHandler } from "./ActivateInternalKycCommandHandler.js";
import { ActivateInternalKycCommandResponse } from "./ActivateInternalKycCommand.js";
import { ActivateInternalKycCommandFixture } from "../../../../../../../__tests__/fixtures/kyc/KycFixture";
import { ActivateInternalKycCommandError } from "./error/ActivateInternalKycCommandError.js";
import { ErrorCode } from "../../../../../../core/error/BaseError";
describe("ActivateInternalKycCommandHandler", () => {
    let handler;
    let command;
    const transactionServiceMock = createMock();
    const validationServiceMock = createMock();
    const accountServiceMock = createMock();
    const contractServiceMock = createMock();
    const evmAddress = new EvmAddress(EvmAddressPropsFixture.create().value);
    const account = new Account({
        id: HederaIdPropsFixture.create().value,
        evmAddress: EvmAddressPropsFixture.create().value,
    });
    const transactionId = TransactionIdFixture.create().id;
    const errorMsg = ErrorMsgFixture.create().msg;
    beforeEach(() => {
        handler = new ActivateInternalKycCommandHandler(accountServiceMock, transactionServiceMock, contractServiceMock, validationServiceMock);
        command = ActivateInternalKycCommandFixture.create();
    });
    afterEach(() => {
        jest.resetAllMocks();
    });
    describe("execute", () => {
        it("throws ActivateInternalKycCommandError when command fails with uncaught error", async () => {
            const fakeError = new Error(errorMsg);
            contractServiceMock.getContractEvmAddress.mockRejectedValue(fakeError);
            const resultPromise = handler.execute(command);
            await expect(resultPromise).rejects.toBeInstanceOf(ActivateInternalKycCommandError);
            await expect(resultPromise).rejects.toMatchObject({
                message: expect.stringContaining(`An error occurred while activating internal KYC: ${errorMsg}`),
                errorCode: ErrorCode.UncaughtCommandError,
            });
        });
        it("should successfully activate internal kyc", async () => {
            contractServiceMock.getContractEvmAddress.mockResolvedValueOnce(evmAddress);
            accountServiceMock.getCurrentAccount.mockReturnValue(account);
            validationServiceMock.checkPause.mockResolvedValue(undefined);
            validationServiceMock.checkRole.mockResolvedValue(undefined);
            transactionServiceMock.getHandler().activateInternalKyc.mockResolvedValue({
                id: transactionId,
            });
            const result = await handler.execute(command);
            expect(result).toBeInstanceOf(ActivateInternalKycCommandResponse);
            expect(result.payload).toBe(true);
            expect(result.transactionId).toBe(transactionId);
            expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledTimes(1);
            expect(accountServiceMock.getCurrentAccount).toHaveBeenCalledTimes(1);
            expect(transactionServiceMock.getHandler().activateInternalKyc).toHaveBeenCalledTimes(1);
            expect(validationServiceMock.checkPause).toHaveBeenCalledWith(command.securityId);
            expect(validationServiceMock.checkRole).toHaveBeenCalledWith(SecurityRole._INTERNAL_KYC_MANAGER_ROLE, account.id.toString(), command.securityId);
            expect(contractServiceMock.getContractEvmAddress).toHaveBeenCalledWith(command.securityId);
            expect(transactionServiceMock.getHandler().activateInternalKyc).toHaveBeenCalledWith(evmAddress, command.securityId);
        });
    });
});
